import {makeAutoObservable} from "mobx";
import {http} from "../utils/http";

export class Payback {
  page = 0;
  pageSize = 10;
  data = [];
  total_data = 0;
  filterCategory = null;
  visibleModalPayback = false;

  pagePayback = 0;
  pageSizePayback = 10;
  dataPayback = [];
  total_dataPayback = 0;

  pageSubPayback = 0;
  pageSizeSubPayback = 10;
  dataSubPayback = [];
  total_dataPayback = 0;

  constructor(ctx) {
    this.ctx = ctx;
    makeAutoObservable(this);
  }

  async getData() {
    try {
      const response = await http.get(
        `/transaction/deposit-return?page=${this.page}&pageSize=${this.pageSize}`
      );
      //console.log(response)
      this.data =
        response.body.data.map((item, idx) => {
          item.key = idx;
          return item;
        }) ?? [];

      this.total_data = response.body.count ?? 0;
    } catch (e) {
      console.error(e);
    }
  }

  async getDataUser() {
    try {
      const response = await http.get(
        `/transaction/deposit-return/confirmation?page=${this.page}&pageSize=${this.pageSize}`
      );
      //console.log(response);
      this.data =
        response.body.data.map((item, idx) => {
          item.key = idx;
          return item;
        }) ?? [];

      this.total_data = response.body.count ?? 0;
    } catch (e) {
      console.error(e);
    }
  }

  async update(id, data) {
    try {
      const response = await http.put(`/config/commission/${id}`).send(data);
      await this.getData();
      return response;
    } catch (e) {
      console.error(e);
    }
  }

  async delete(id) {
    try {
      const response = await http.del(`/product/${id}`);
      await this.getData();
      return response;
    } catch (e) {
      console.error(e);
    }
  }
  async create(data) {
    try {
    console.log(data)
      return await http.post("/transaction/deposit-return").send(data);
      
    } catch (e) {
      console.error(e);
    }
  }
}
